fopen macro FileName,fMode
	pushi ebx,ecx,edx
	if @InStr(1,<FileName>,<!">)
		if @InStr(1,<fMode>,<!"rb>)
			invoke CreateFile,T(FileName),GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
		elseif @InStr(1,<fMode>,<!"rw>)
			invoke CreateFile,T(FileName),GENERIC_READ or GENERIC_WRITE ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
		else
			invoke CreateFile,T(FileName),GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
		endif
	else
		if @InStr(1,<fMode>,<!"rb>)
			invoke CreateFile,FileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
		elseif @InStr(1,<fMode>,<!"rw>)
			invoke CreateFile,FileName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
		else
			invoke CreateFile,FileName,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
		endif
	endif
	poppi ebx,ecx,edx
	
	exitm <eax>
endm
fclose macro FileH
	pushad
	invoke CloseHandle,FileH
	popad
endm
fread macro FileH,Where,What
	pushad
	ifndef fread_bytesread
	.data?
		fread_bytesread dd ?
	.code
	endif
	invoke ReadFile,FileH,Where,What,addr fread_bytesread,0
	popad
endm

fwrite macro FileH,Where,What
	pushad
	ifndef fread_bytesread
	.data?
		fread_bytesread dd ?
	.code
	endif
	invoke WriteFile,FileH,Where,What,addr fread_bytesread,0
	popad
endm

fsize macro FileH
	push ebx
	push ecx
	push edx
	invoke GetFileSize,FileH,0
	pop edx
	pop ecx
	pop ebx
	exitm <eax>
endm

FetchFileData macro FileName
	local _done,f1,filesize1,bytesread,pointa1
	pushi ecx,edx
	if @InStr(1,<FileName>,<!">)
		invoke CreateFile,T(FileName),GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	else
		invoke CreateFile,FileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	endif
	sub esp,16
	mov ebx,esp
	
	
	f1        textequ <dword ptr[ebx+0]>
	filesize1 textequ <dword ptr[ebx+4]>
	bytesread textequ <dword ptr[ebx+8]>
	pointa1   textequ <dword ptr[ebx+12]>
	
	mov f1,eax
	xor eax,eax
	cmp f1,-1
	je _done
	invoke GetFileSize,f1,0
	mov filesize1,eax
	
	add eax,50 ; 50 extra bytes just in case
	mov eax,malloc(eax)
	mov pointa1,eax
	
	invoke ReadFile,f1,pointa1,filesize1,addr bytesread,0
	invoke CloseHandle,f1
	mov eax,pointa1
	mov ebx,filesize1
	_done:
	add esp,16
	popi ecx,edx
	or eax,eax
	exitm <eax>
endm


DumpDataToFile macro FileName,DataPtr,DataSiz
	pushad
	
	ifndef	ddtfile_f1
	.data?
		ddtfile_f1 dd ?
		ddtfile_br dd ? ; bytes read
	.code
	endif
	
	if @InStr(1,<FileName>,<!">)
		invoke CreateFile,T(FileName),GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
	else
		invoke CreateFile,FileName,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
	endif
	mov ddtfile_f1,eax
	invoke WriteFile,ddtfile_f1,DataPtr,DataSiz,addr ddtfile_br,0
	invoke CloseHandle,ddtfile_f1
	
	popad
	
endm